#if !defined NETHER && !defined END
	uniform vec3 skyColor, sunPosition;
#endif

uniform vec3 fogColor;
uniform float fogStrength;
uniform int isEyeInWater;

float fog(float dist) {
	return min(pow(dist * lowp_rcp(far), fogStrength), 1.0);
}

float sky_fog(float height) {
	return 0.25 * lowp_rcp(fma(height, height, 0.25));
}

#ifndef NETHER
	#ifdef END
		vec3 sky(vec3 n_plr) {
			return mix(rand(fma(trunc(gl_GlobalInvocationID.xy * 0.25), vec2(4.0), frameTimeCounter.xx)).xxx, rand(floor(n_plr.xz * 1024.0 + frameTimeCounter * 1)).rrr * vec3(0.05, 0.0, 0.05) * (1.25 - n_plr.y), 0.99);
		}
	#else
		vec3 sky(float sky_fog, vec3 n_view) {
			vec3 color = mix(linear(skyColor), linear(fogColor), sky_fog);

			#if SUN_BLOOM || SKY_BLOOM
				if (isEyeInWater == 0) {
					immut float view_dot_sun = dot(n_view, sunPosition * 0.01);

					immut float sun = max(0.0, view_dot_sun);
					immut float moon = max(0.0, -view_dot_sun) * moonSize * 0.2;

					color = fma(vec3(SUN_BLOOM * pow(sun, 256u) + SKY_BLOOM * pow(sun, 3u)), vec3(0.15, 0.15, 1.38), color);
					color = fma(vec3(SUN_BLOOM * pow(moon, 256u) + SKY_BLOOM * pow(moon, 3u)), vec3(0.0013, 0.0014, 0.0019), color);
				}
			#endif

			return color;
		}
	#endif
#endif