#include "/lib/core.glsl"

/*
	const bool shadowcolor0Clear = false;
	const bool shadowHardwareFiltering1 = true;
	// RGB565 would be nice here
	const int shadowcolor0Format = RGB5_A1;
	const float shadowIntervalSize = 0.0;
*/

/* RENDERTARGETS: 0 */
layout(location = 0) out vec3 outColor;

#ifdef TEXTURED
	uniform float alphaTestRef;
	uniform sampler2D gtexture;

	in VertexData { noperspective vec2 pix; } v;

	#ifdef TRANSLUCENT
		#include "/lib/srgb.glsl"
	#endif
#else
	layout(depth_unchanged) out float gl_FragDepth;
#endif

void main() {
	#ifdef TEXTURED
		#ifdef TRANSLUCENT
			immut vec4 color = texelFetch(gtexture, ivec2(v.pix), 0);
			if (color.a < alphaTestRef) discard;

			outColor = mix(vec3(1.0), linear(color.rgb), color.a - 256.0 * max(0.0, color.a - 255.0/256.0));
		#else
			if (texelFetch(gtexture, ivec2(v.pix), 0).a < alphaTestRef) discard;
		#endif
	#else
		outColor = vec3(1.0);
	#endif
}