// Legacy-ish. Should probable rewrite

#if defined HAND_LIGHT && !defined LIGHT_LEVELS
	uniform float handLight;
#endif

uniform float day;

#if COLORED_LIGHT || GLOSSY_REFLECTIONS
	uniform usampler1D lightIndexS;
#endif

in ivec2 vaUV2;

#include "/lib/luma.glsl"
#include "/lib/srgb.glsl"

vec3 get_fancy_light(vec3 view, vec3 normal) {
	vec2 light = ((
		mat4(0.00390625, 0.0, 0.0, 0.0, 0.0, 0.00390625, 0.0, 0.0, 0.0, 0.0, 0.00390625, 0.0, 0.03125, 0.03125, 0.03125, 1.0) *
		vec4(vaUV2, 0.0, 1.0)
	).xy - 1.0/32.0) * 16.0/15.0; // lm_coord scaled to 0-1

	#ifdef NETHER
		const vec3 sky_light = vec3(0.3, 0.15, 0.2);
	#elif defined END
		const vec3 sky_light = vec3(0.15, 0.075, 0.2);
	#else
		immut float sky_light = 1.0 - lowp_sqrt(1.0 - max(0.1, light.y * clamp(day * 10.0, 0.25, 1.0))); // What was I thinking
	#endif

	immut float dist = length(view);

	#ifdef LIGHT_LEVELS
		vec3 block_light = light.x > 0.0 ? mix(
			vec3(0.5, 0.25, 0.0),
			mix(
				vec3(0.75, 0.5, 0.0),
				mix(
					vec3(1.0, 0.75, 0.0),
					vec3(1.0, 1.0, 1.0),
					smoothstep(8.0, 15.0, light.x)
				),
				smoothstep(8.0, 11.0, light.x)
			),
			smoothstep(1.0, 7.0, light.x)
		) : vec3(0.5, 0.0, 0.0);
	#else
		#ifdef HAND_LIGHT
			light.x = mix(light.x, 1.0, max(0.0, handLight - dist * lowp_rcp(handLight * 16.0)));
		#endif

		vec3 block_light = light.xxx;
	#endif

	#if COLORED_LIGHT || GLOSSY_REFLECTIONS
		if (light.x >= float(MIN_INDEX_LL - 1) / 15.0 && dist < float(INDEX_DIST)) {
			vec3 shine = vec3(0.0);

			immut vec3 neg_view_index_dist = -view - float(INDEX_DIST);

			const float default_smoothness = 0.1;
			const float reflectance = default_smoothness * default_smoothness * float(SPECULAR * 10);
			const float smoothness = fma(lowp_sqrt(default_smoothness), 3.0, 1.0);

			immut vec3 n_view = normalize(view);

			for(int i = 0; i < light_index; ++i) {
				immut uvec2 light_data = texelFetch(lightIndexS, i, 0).rg;

				immut vec3 pos = fma(vec3(
					bitfieldExtract(light_data.x, 0, 16),
					bitfieldExtract(light_data, 16, 16)
				), vec3(float(INDEX_DIST * 2) / 65535.0), neg_view_index_dist);

				immut float pos_len = length(pos);
				immut float emission = bitfieldExtract(light_data.y, 0, 4);
				immut float dist = pos_len - 1.0;

				if (dist <= emission) {
					immut vec3 n_pos = pos * lowp_rcp(pos_len);
					immut float lambertian = dot(normal, n_pos);
					immut float lighting = lambertian > 0.01 ? fma(pow(max(dot(n_view, n_pos), 0.0), smoothness), reflectance, lambertian) : IND_ILLUM;

					shine = fma(vec3(
						bitfieldExtract(light_data.y, 12, 4),
						bitfieldExtract(light_data.y, 8, 4),
						bitfieldExtract(light_data.y, 4, 4)
					), vec3(lighting * (emission - dist)), shine);
				}
			}

			if (dot(shine, vec3(1.0)) > 0.01) {
				shine /= 225.0; // Undo the multiplication from packing light color and emission

				vec3 new_light = block_light;

				#if COLORED_LIGHT
					immut vec3 color = normalize(shine);

					new_light = mix(new_light, new_light * color * lowp_rcp(luminance(color)), COLORED_LIGHT * 0.1);
				#endif

				#if GLOSSY_REFLECTIONS
					new_light = fma(light.x * shine, vec3(GLOSSY_REFLECTIONS * 0.15), new_light);
				#endif

				block_light = mix(block_light, new_light, (1.0 - smoothstep(float(INDEX_DIST - 15), float(INDEX_DIST), dist)));
			}
		}
	#endif

	return sky_light * 1.25 + (block_light * vec3(1.0, 0.8, 0.7) * lowp_rcp(1.0 + sky_light));
}