uniform float frameTimeCounter;
uniform vec2 cameraTopDown;

float wave(vec2 pos) {
	immut float time = frameTimeCounter * WAVE_SPEED;

	pos += cameraTopDown;
	pos = sin(pos + time) + sin(pos * 0.5 + time * 3.0);

	return fma(pos.x, pos.y, -1.0) * (float(WAVES) * 0.005);
}

vec3 wave_normal(vec2 pos) {
	immut float mul = float(WAVES) * 0.005;
	immut float time = frameTimeCounter * WAVE_SPEED;

	return normalize(vec3(
		mul * (cos(pos.x + time) + 0.5 * cos(0.5 * pos.x + 3.0 * time)),
		1,
		mul * (cos(pos.y + time) + 3.0 * cos(0.5 * pos.y + 3.0 * time))
	));
}