#include "/lib/core.glsl"
#include "/lib/config.glsl"

const ivec3 workGroups = ivec3(1, 1, 1);
layout(local_size_x = 1, local_size_y = 1, local_size_z = 1) in;

#if DCG_EXP || DCG_COLOR || DCG_BP
	writeonly restrict layout(shared, binding = 0) buffer dcgBuffer {
		vec3 max_color;
		float max_luma, min_val;
	} dcg;
#endif

#if COLORED_LIGHT || GLOSSY_REFLECTIONS
	layout(shared, binding = 1) restrict writeonly buffer lightIndexLen { int light_index; };
#endif

void main() {
	#if DCG_EXP || DCG_COLOR || DCG_BP
		dcg.max_color = vec3(1.0);
		dcg.min_val = 0.0;
		dcg.max_luma = 1.0;
	#endif

	#if COLORED_LIGHT || GLOSSY_REFLECTIONS
		light_index = 0;
	#endif
}